.\" $NetBSD: time_second.9,v 1.3 2008/11/28 22:31:01 wiz Exp $
.\"
.\" Copyright (c) 1994 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"          This product includes software developed for the
.\"          NetBSD Project.  See http://www.NetBSD.org/ for
.\"          information about NetBSD.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" <<Id: LICENSE,v 1.2 2000/06/14 15:57:33 cgd Exp>>
.\"
.Dd November 28, 2008
.Dt TIME_SECOND 9
.Os
.Sh NAME
.Nm time_second ,
.Nm time_uptime ,
.Nm boottime
.Nd system time variables
.Sh SYNOPSIS
.In sys/time.h
.Vt extern time_t time_second;
.Vt extern time_t time_uptime;
.In sys/kernel.h
.Vt extern struct timeval boottime;
.Sh DESCRIPTION
The
.Va time_second
variable is the system's
.Dq wall time
clock.
It is set at boot by
.Xr inittodr 9 ,
and is updated periodically via
.Xr timecounter 9
framework, and also updated by the
.Xr settimeofday 2
system call.
.Pp
The
.Va time_uptime
variable is a monotonically increasing system clock.
It is set at boot, and is updated periodically.
(It is not updated by
.Xr settimeofday 2 . )
.Pp
The
.Va boottime
variable holds the system boot time.
It is set at system boot, and is updated when the system time is adjusted
with
.Xr settimeofday 2 .
.Pp
All of these variables contain times
expressed in seconds and microseconds since midnight (0 hour),
January 1, 1970.
.Pp
The
.Xr bintime 9 ,
.Xr getbintime 9 ,
.Xr microtime 9 ,
.Xr getmicrotime 9 ,
.Xr nanotime 9 ,
and
.Xr getnanotime 9
functions can be used to get the current time more accurately and in an
atomic manner.
.Pp
Similarly, the
.Xr binuptime 9 ,
.Xr getbinuptime 9 ,
.Xr microuptime 9 ,
.Xr getmicrouptime 9 ,
.Xr nanouptime 9 ,
and
.Xr getnanouptime 9
functions can be used to get the time elapsed since boot more accurately
and in an atomic manner.
.Pp
.Va boottime
may be read and written without special precautions.
.Sh SEE ALSO
.Xr clock_settime 2 ,
.Xr ntp_adjtime 2 ,
.Xr settimeofday 2 ,
.Xr bintime 9 ,
.Xr binuptime 9 ,
.Xr getbintime 9 ,
.Xr getbinuptime 9 ,
.Xr getmicrotime 9 ,
.Xr getmicrouptime 9 ,
.Xr getnanotime 9 ,
.Xr getnanouptime 9 ,
.Xr hardclock 9 ,
.Xr hz 9 ,
.Xr inittodr 9 ,
.Xr microtime 9 ,
.Xr microuptime 9 ,
.Xr nanotime 9 ,
.Xr nanouptime 9 ,
.Xr timecounter 9
